\\ Copyright 2013, 2014, 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

b = 1+2*I;
RQ(k) = 3^k;
J(k) = (3^k-1)/2;
GRQ(k) = (2/5 - 1/5*I)*b^k + (1/10 - 3/10*I)*(1/3)^k;

GJN_samples_by_path = { 1/2 * [
   (1) + (5)*I,   /* k=1 */
   (-32) + (24)*I,   /* k=2 */
   (-247) + (-131)*I,   /* k=3 */
   (64) + (-1904)*I,   /* k=4 */
   (11697) + (-5323)*I,   /* k=5 */
   (67104) + (54376)*I,   /* k=6 */
   (-125191) + (566061)*I,  /* k=7 */
   (-3772800) + (946848)*I,   /* k=8 */
   (-16999967) + (-19798171)*I   /* k=9 */
]};

check_exact(got,want) =
{
  if(got != want,
     print("wrong\n");
     print("got  " got);
     print("want " want);
     quit(1),
     print("ok"));
}

GJ(k) = (9/10 + 3/10*I)*b^k \
        + (2/5 - 1/5*I) * (b^k - 1)/(3^k-1);
GJN(k) = J(k)*GJ(k);
check_exact(vector(length(GJN_samples_by_path),k, GJN(k)), GJN_samples_by_path)


\\-----------------------------------------------------------------------------
\\ JEP
JEP_samples = [ 1, 0+2*I, -4+1*I, -5-7*I, 9-16*I, 40+2*I, 36+81*I, -125+153*I ];

JEP(k) =
{
  my(ret=1, dir=-1);
  for(i=1,k, ret*=b; ret+=dir; dir*=I);
  ret;
}
check_exact(vector(#JEP_samples,k,my(k=k-1); JEP(k)), JEP_samples)

\\ b^0
\\ b^1 - 1
\\ b^2 - b^1 - I
\\ b^3 - b^2 - I*b^1 - I^2
JEP(k) = b^k - sum(j=0,k-1, I^j*b^(k-1-j));
check_exact(vector(#JEP_samples,k,my(k=k-1); JEP(k)), JEP_samples)

JEP(k) = b^k - (b^k - I^k)/(b-I);
check_exact(vector(#JEP_samples,k,my(k=k-1); JEP(k)), JEP_samples)

JEP(k) = b^k - (1/2 - 1/2*I) * (b^k - I^k);
check_exact(vector(#JEP_samples,k,my(k=k-1); JEP(k)), JEP_samples)

\\ square middle, then to corner in mod 4
JEP(k) = (1/2 + 1/2*I)*b^k + (1/2 - 1/2*I) * I^k;
check_exact(vector(#JEP_samples,k,my(k=k-1); JEP(k)), JEP_samples)

\\-----------------------------------------------------------------------------

GJN_triple(k) = (3^k-1)/2 * ( (9/10 + 3/10*I)*b^k \
                             + (2/5 - 1/5*I) * (b^k - 1)/(3^k-1) );
check_exact(vector(100,k, GJN_triple(k)), \
            vector(100,k, GJN(k)))

GJN_triple(k) = (3^k-1)* (9/20 + 3/20*I)*b^k + (2/10 - 1/10*I) * (b^k - 1);
check_exact(vector(100,k, GJN_triple(k)), \
            vector(100,k, GJN(k)))

GJN_triple(k) = 3^k* (9/20 + 3/20*I)*b^k \
                - 1*(9/20 + 3/20*I)*b^k \
                + (2/10 - 1/10*I) * b^k \
                - (2/10 - 1/10*I);
check_exact(vector(100,k, GJN_triple(k)), \
            vector(100,k, GJN(k)))

GJN_triple(k) = 3^k* (9/20 + 3/20*I)*b^k \
                + (-1/4 - 1/4*I) * b^k \
                - (2/10 - 1/10*I);
check_exact(vector(100,k, GJN_triple(k)), \
            vector(100,k, GJN(k)))

GJN_triple(k) =
{
  3*b*GJN(k-1) 
  -3*b*( + 3^(k-1)* (9/20 + 3/20*I)*b^(k-1) 
        + (-1/4 - 1/4*I) * b^(k-1) 
        - (2/10 - 1/10*I)
       )
        + 3^k* (9/20 + 3/20*I)*b^k 
        + (-1/4 - 1/4*I) * b^k 
        - (2/10 - 1/10*I);
}
check_exact(vector(100,k, GJN_triple(k+1)), \
            vector(100,k, GJN(k+1)))

\\ triples out and midpoint
GJN_triple(k) = 3*b*GJN(k-1)  + (1/2 + 1/2*I)*b^k + (1 + I);
check_exact(vector(100,k, GJN_triple(k+1)), \
            vector(100,k, GJN(k+1)))

check_exact((1/2 + 5/2*I)*b, -9/2+7/2*I)

triple_offset(k) = GJN(k+1) - 3*b*GJN(k);
vector(10,k, triple_offset(k))
vector(10,k, (1/2+1/2*I)*b^(k+1) + (1 + I) )

\\-----------------------------------------------------------------------------
\\ GJ(k) delta

GJ_delta(k) = GJ(k+1) - GJ(k);
check_exact(vector(100,k, GJ_delta(k)), \
            vector(100,k, GJ(k+1) - GJ(k)))

GJ_delta(k) =
{
  (9/10 + 3/10*I)*b^(k+1) \
  + (2/5 - 1/5*I) * (b^(k+1) - 1)/(3^(k+1)-1)
  - (9/10 + 3/10*I)*b^k \
  - (2/5 - 1/5*I) * (b^k - 1)/(3^k-1);
}
check_exact(vector(100,k, GJ_delta(k)), \
            vector(100,k, GJ(k+1) - GJ(k)))

GJ_delta(k) =
{
  (3/5 + 3/5*I)*b^(k+1) \
  + (2/5 - 1/5*I) * (b^(k+1) - 1)/(3^(k+1)-1)
  - (2/5 - 1/5*I) * (b^k - 1)/(3^k-1);
}
check_exact(vector(100,k, GJ_delta(k)), \
            vector(100,k, GJ(k+1) - GJ(k)))


\\-----------------------------------------------------------------------------
\\ GJ(k) mul b

GJ_mul(k) =
{
  b*GJ(k-1) 
  - b*(9/10 + 3/10*I)*b^(k-1) + - b*(2/5 - 1/5*I) * (b^(k-1) - 1)/(3^(k-1)-1)
  + (9/10 + 3/10*I)*b^k \
  + (2/5 - 1/5*I) * (b^k - 1)/(3^k-1);
}
check_exact(vector(100,k, GJ_mul(k+1)), \
            vector(100,k, GJ(k+1)))

GJ_mul(k) =
{
  b*GJ(k-1) 
  + ( - (4/5 + 3/5*I) * (b^(k-1) - 1)*(3^k-1)
     + (2/5 - 1/5*I) * (b^k - 1)*(3^(k-1)-1)
     ) /(3^k-1)/(3^(k-1)-1);
}
check_exact(vector(100,k, GJ_mul(k+1)), \
            vector(100,k, GJ(k+1)))

GJ_mul(k) =
{
  b*GJ(k-1) 
  + (  - (4/5 + 3/5*I) *b^(k-1)*3^k + (4/5 + 3/5*I) *b^(k-1)
     + (4/5 + 3/5*I)*3^k - (4/5 + 3/5*I)*1
     + (2/5 - 1/5*I) * b^k*3^(k-1)
     - (2/5 - 1/5*I) * b^k 
     - (2/5 - 1/5*I) * 3^(k-1)
     +(2/5 - 1/5*I)
     ) /(3^k-1)/(3^(k-1)-1);
}
check_exact(vector(100,k, GJ_mul(k+1)), \
            vector(100,k, GJ(k+1)))

GJ_mul(k) =
{
  b*GJ(k-1) 
  + ((-4/5 + 2/5*I) *b^k*3^(k-1)
     + (2 + 2*I) * 3^(k-1)
     + (-2/5 - 4/5*I)
     ) /(3^k-1)/(3^(k-1)-1);
}
check_exact(vector(100,k, GJ_mul(k+1)), \
            vector(100,k, GJ(k+1)))

