\\ Copyright 2013, 2014, 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

b = 1+2*I;
RQ(k) = 3^k;
J(k) = (3^k-1)/2;
GRQ(k) = (2/5 - 1/5*I)*b^k + (1/10 - 3/10*I)*(1/3)^k;

GJN_samples_by_path = { 1/2 * [
   (1) + (5)*I,   /* k=1 */
   (-32) + (24)*I,   /* k=2 */
   (-247) + (-131)*I,   /* k=3 */
   (64) + (-1904)*I,   /* k=4 */
   (11697) + (-5323)*I   /* k=5 */
]};

check_exact(got,want) =
{
  if(got != want,
     print("wrong\n");
     print("got  " got);
     print("want " want);
     quit(1),
     print("ok"));
}

\\ J(k)*GJ(k) + (1/2+1/2*I)*b^k + J(k)*(b^k+I*GJ(k))) == vector(100,k, RQ(k)*((1+I)*b^k - I*GRQ(k)))

GJ(k) =  1/((1+I)*J(k))*( RQ(k)*((1+I)*b^k - I*GRQ(k)) - (1/2+1/2*I)*b^k - J(k)*b^k );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  1/((1+I)*(3^k-1)/2)*( 3^k*((1+I)*b^k - I*((2/5 - 1/5*I)*b^k + (1/10 - 3/10*I)*(1/3)^k)) - (1/2+1/2*I)*b^k - (3^k-1)/2*b^k );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  1/((1+I)*(3^k-1)/2)*(  + (-1/2-1/2*I -1/2*3^k +1/2 + 3^k*(1+I) )*b^k \
                              + 3^k*(- I*((2/5 - 1/5*I)*b^k + (1/10 - 3/10*I)*(1/3)^k)) );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  1/((1+I)*(3^k-1)/2)*(+ (-1/2*I -1/2*3^k + 3^k*(1+I) )*b^k \
                              + (- I*3^k*(2/5 - 1/5*I)*b^k \
                                 - I*3^k*(1/10 - 3/10*I)*(1/3)^k) );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  1/((1+I)*(3^k-1)/2)*(-3/10 - 1/10*I \
                              + (-1/2*I -1/2*3^k + 3^k*(1+I) - I*3^k*(2/5 - 1/5*I))*b^k \
                              );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  1/((1+I)*(3^k-1)/2)*(-3/10 - 1/10*I \
                              + (-1/2*I -1/2*3^k + 3^k*(1+I) - I*3^k*2/5 + I*3^k*1/5*I)*b^k \
                              );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  1/((1+I)*(3^k-1)/2)*(-3/10 - 1/10*I \
                              + (-1/2*I -1/2*3^k + 3^k*(1+I - I*2/5 + I*1/5*I))*b^k \
                              );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  1/(3^k-1) * ((1 - I) *(-3/10 - 1/10*I) \
                              + (1 - I) *(-1/2*I + 3^k*(3/10 + 3/5*I))*b^k \
                              );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  1/(3^k-1) * (-2/5 + 1/5*I \
                      + ((-1/2 - 1/2*I) + 3^k*(9/10 + 3/10*I))*b^k \
                     );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  1/(3^k-1) * (-2/5 + 1/5*I \
                      + (-1/2 - 1/2*I)*b^k \
                      + (9/10 + 3/10*I)*3^k*b^k \
                     );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  1/(3^k-1) * (-2/5 + 1/5*I \
                      + (-1/2 - 1/2*I)*b^k \
                      + (9/10 + 3/10*I)*(+1)*b^k \
                      + (9/10 + 3/10*I)*(3^k-1)*b^k \
                     );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) = (9/10 + 3/10*I)*b^k \
        + 1/(3^k-1) * (-2/5 + 1/5*I \
                      + (2/5 - 1/5*I)*b^k \
                     );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) = (9/10 + 3/10*I)*b^k \
        + (2/5 - 1/5*I) * (b^k - 1)/(3^k-1);
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

for(k=1,20,print(GJ(k)))

\\-----------------------------------------------------------------------------
\\ expressed in terms of GRQ(k)

GJ(k) =  - (1/2 - 1/2*I) * b^k \
         + (1/2 - 1/2*I) * 1/J(k) \
           * ( RQ(k)*(1+I)*b^k - I*(2*J(k)+1)*GRQ(k) - (1/2+1/2*I)*b^k );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  - (1/2 - 1/2*I) * b^k \
         + (1/2 - 1/2*I) * 1/J(k) \
           * ( RQ(k)*(1+I)*b^k - I*2*J(k)*GRQ(k) - I*GRQ(k) - (1/2+1/2*I)*b^k );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  - (1/2 - 1/2*I) * b^k \
         - (1/2 - 1/2*I) * I*2*GRQ(k) \
         + (1/2 - 1/2*I) * 1/J(k) \
           * ( RQ(k)*(1+I)*b^k - I*GRQ(k) - (1/2+1/2*I)*b^k );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  - (1/2 - 1/2*I) * b^k \
         - (1 + I) * GRQ(k) \
         + (1/2 - 1/2*I) * 1/J(k) \
           * ( (2*J(k)+1)*(1+I)*b^k - I*GRQ(k) - (1/2+1/2*I)*b^k );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  - (1/2 - 1/2*I) * b^k \
         - (1 + I) * GRQ(k) \
         + (1/2 - 1/2*I) * 1/J(k) \
           * ( 2*J(k)*(1+I)*b^k + 1*(1+I)*b^k - I*GRQ(k) - (1/2+1/2*I)*b^k );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  - (1/2 - 1/2*I) * b^k \
         - (1 + I) * GRQ(k) \
         + (1/2 - 1/2*I) * 2*(1+I)*b^k \
         + (1/2 - 1/2*I) * 1/J(k) \
           * ( (1+I)*b^k - I*GRQ(k) - (1/2+1/2*I)*b^k );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  (3/2 + 1/2*I) * b^k \
         - (1 + I) * GRQ(k) \
         + (1/2 - 1/2*I) * 1/J(k) \
           * ( (1+I)*b^k - I*GRQ(k) - (1/2+1/2*I)*b^k );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  (3/2 + 1/2*I) * b^k \
         - (1 + I) * GRQ(k) \
         + 1/J(k) \
           * ( 1/2*b^k - (1/2 + 1/2*I)*GRQ(k) );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)


\\ GRQ(k) = (2/5 - 1/5*I)*b^k + (1/10 - 3/10*I)*(1/3)^k;
\\ GRQ(k)-GRQ(k-1) = (2/5 - 1/5*I)*(b^k - b^(k-1)) + (1/10 - 3/10*I)*((1/3)^k-(1/3)^(k-1));

GJ(k) =  (3/2 + 1/2*I) * b^k \
         - (1 + I) * (GRQ(k-1) + (2/5 - 1/5*I)*(b^k - b^(k-1)) + (1/10 - 3/10*I)*((1/3)^k-(1/3)^(k-1))) \
         + 1/J(k) \
           * ( 1/2*b^k - (1/2 + 1/2*I)*GRQ(k) );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  (3/2 + 1/2*I) * b^k \
         - (1 + I) * GRQ(k-1) \
         - (1 + I) * (2/5 - 1/5*I)*(b^k - b^(k-1)) \
         - (1 + I) * (1/10 - 3/10*I)*((1/3)^k-(1/3)^(k-1)) \
         + 1/J(k) \
           * ( 1/2*b^k - (1/2 + 1/2*I)*GRQ(k) );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

GJ(k) =  (11/10 + 1/10*I) * b^k \
         + (4/5 - 2/5*I) * (1/3)^k \
         - (1 + I) * GRQ(k-1) \
         + 1/J(k) \
           * ( 1/2*b^k - (1/2 + 1/2*I)*GRQ(k) );
check_exact(vector(length(GJN_samples_by_path),k, J(k)*GJ(k)), GJN_samples_by_path)

